
// This removes spaces at the ends of lines.
theText = theText.replaceAll(" " + EOL, EOL)
theText = theText.replaceAll(" " + EOL, EOL)
theText = theText.replaceAll(" " + EOL, EOL)

// This fixes em-dashes.
theText = theText.replaceAll("—", " -- ")

// This removes the header ChatGPT adds.
theText = theText.replace("Here’s a proofread version of your text with some minor adjustments for clarity and consistency:" + EOL + EOL + "---"  + EOL + EOL, "")

// Inserts blank line after About block.
var pos as integer = theText.indexOf("About the Author: ")
if pos > 0 then
   pos = theText.indexOf(pos, EOL)
   theText = theText.left(pos) + EOL + EOL + theText.middle(pos + len(EOL))
end if

// Inserts blank line before each header.
var headerEnd as integer = theText.indexOf(EOL + EOL)
var header as string = theText.left(headerEnd)
var body as string = theText.middle(headerEnd)

body = body.replaceAll(EOL + "#", EOL + EOL + "#")
theText = header + body


// This fixes code blocks.
while theText.contains("```")
  fixCodeBlocks
wend





sub fixCodeBlocks()
  var theStart as integer = theText.indexOf("```")
  var theEnd as integer = theText.indexOf(theStart + 3, "```") + 3
  var theCode as string = theText.middle(theStart, theEnd - theStart)
  var lines() as string = theCode.split(eol)
  
  // This removes the ``` tags.
  lines.remove(0)
  lines.remove(lines.lastIndex)
  
  // This replaces indents with tabs.
  for i as integer = 0 to lines.lastIndex
    lines(i) = lines(i).replaceAll("    ", chr(9))
    lines(i) = chr(9) + lines(i)
  next i
  
  theCode = join(lines, EOL)
  theText = theText.left(theStart) + theCode + theText.middle(theEnd)
end sub
